#import <appkit/View.h>
#import <appkit/Window.h>
#import <appkit/NXImage.h>

#define NX_FROMINPUT	0
#define NX_FROMVIEW  	1

#define NX_NTSCSIGNAL 0
#define NX_PALSIGNAL  1

#define    NX_VIDEOIN1      /* video input ports */  1
#define    NX_VIDEOIN2                               2
#define    NX_VIDEOIN3                               3

@interface NXLiveVideoView : View
{
    void	*_private;
    id	  	_anImage;
    Window	*_cWindow;
    int		_input;
    float 	_inputGamma;
    float 	_outputGamma;
    float 	_inputBrightness;
    float 	_inputHue;
    float 	_inputSaturation;
    float	_inputContrast;
    float	_inputSharpness;
    id		delegate;
    struct __vidFlags {
    unsigned int        running:1;
    unsigned int        paused:1;
    unsigned int        validImage:1;
    unsigned int	stopGrab:1;
    unsigned int	outmode:1;
    unsigned int	hasVideoResource:1;
    unsigned int	everHadVideoResource:1;
    unsigned int 	genlock:1;
    unsigned int	stopping:1;
    unsigned int	spare:23;
    }                   _vidFlags;
    int 	_pad[4];
} 

+ (const NXScreen *) videoScreen;
+ (BOOL)doesScreenSupportVideo: (const NXScreen *) screen
	standard: (int *) standard
	size: (NXSize *) size;
+ (BOOL)doesWindowSupportVideo: (id) window
 	standard: (int *) standard
	size: (NXSize *) size;
+ (BOOL)doesRectSupportVideo: (NXRect *) rect
 	standard: (int *) standard
	size: (NXSize *) size;
- initFrame:(const NXRect *)frameRect;
- free;
- getVideoStandard:(int *) standp size:(NXSize *)sizep;
- (BOOL) isVideoActive;
- drawVideoBackground: (const NXRect *)rects : (int) count;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- start:sender;
- stop:sender;
- (NXImage *) grab;		
- grabIn:(NXImage *)image fromRect:(NXRect *)fromRect toRect:(NXRect *)toRect;
- getSourceVideoRect:(NXRect *)aRect;
- (int) numInputs;
- selectInput: (int)input;
- setOutputMode: (int)source;
- (BOOL)doesGrabOnStop;
- setGrabOnStop:(BOOL)flag;	
- setInputHue: (float) angle;
- (float)inputHue;
- setInputSaturation: (float) saturation;	
- (float)inputSaturation;
- setInputBrightness: (float) brightness;
- (float)inputBrightness;
- setInputSharpness: (float) sharpness;
- (float)inputSharpness;
- setInputGamma: (float) gamma;
- (float) inputGamma;
- resetPictureDefaults;
- setOutputGamma: (float) gamma;
- (float) outputGamma;
- setOutputGenlocked: (BOOL) flag;
- (BOOL) outputGenlocked;
- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;
- setDelegate: delegate;
- delegate;

@end

@interface Object(NXLiveVideoViewDelegate)
- videoDidActivate: sender;
- videoDidSuspend: sender;
@end










